<?php
namespace Ep\TecDoc\Hydrator;

use Interop\Container\ContainerInterface;
use Interop\Container\Exception\ContainerException;
use Zend\Hydrator\Reflection as ReflectionHydrator;
use Zend\Hydrator\Strategy\ClosureStrategy;
use Zend\ServiceManager\Exception\ServiceNotCreatedException;
use Zend\ServiceManager\Exception\ServiceNotFoundException;
use Zend\ServiceManager\Factory\FactoryInterface;

/**
 * Class VehicleByIds4RecordHydradorFactory
 *
 * @package Ep\TecDoc\Hydrator
 * @author Elektronika Perhoč <web@ep.hr>
 * @link http://gitlab.ep.local/ep-framework/tecdoc
 */
class VehicleByIds4RecordHydratorFactory implements FactoryInterface
{
    public function __invoke(ContainerInterface $container, $requestedName, array $options = null)
    {
        $hydrator = new ReflectionHydrator();

        $hydrator->addStrategy('vehicleDetails', new ClosureStrategy(
            null,
            function ($data) {
                var_dump($data);
            }
        ));

        return $hydrator;
    }
}