<?php
namespace Ep\TecDoc\Record;

use Ep\TecDoc\Record\Seq\AxleByCarIdRecordSeq;
use Ep\TecDoc\Record\Seq\CabsByCarIdRecordSeq;
use Ep\TecDoc\Record\Seq\KbaNumbersByVehicleIdRecordSeq;
use Ep\TecDoc\Record\Seq\MotorCodesByCarIdRecordSeq;
use Ep\TecDoc\Record\Seq\SecondaryTypesByCarIdRecordSeq;
use Ep\TecDoc\Record\Seq\VehiclePrototypeRecordSeq;
use Ep\TecDoc\Record\Seq\WheelBasesByCarIdRecordSeq;

/**
 * Class VehicleByIds4Record
 *
 * @package Ep\TecDoc\Record
 * @author Elektronika Perhoč <web@ep.hr>
 * @link http://gitlab.ep.local/ep-framework/tecdoc
 */
class VehicleByIds4Record implements RecordInterface
{
    /** @var \Ep\TecDoc\Record\Seq\AxleByCarIdRecordSeq */
    protected $axles;
    /** @var \Ep\TecDoc\Record\Seq\CabsByCarIdRecordSeq */
    protected $cabs;
    /** @var int */
    protected $carId;
    /** @var \Ep\TecDoc\Record\Seq\KbaNumbersByVehicleIdRecordSeq */
    protected $kbaNumbers;
    /** @var \Ep\TecDoc\Record\Seq\MotorCodesByCarIdRecordSeq */
    protected $motorCodes;
    /** @var \Ep\TecDoc\Record\Seq\VehiclePrototypeRecordSeq */
    protected $protoTypes;
    /** @var \Ep\TecDoc\Record\Seq\SecondaryTypesByCarIdRecordSeq */
    protected $secondaryTypes;
    /** @var \Ep\TecDoc\Record\VehicleByIdRecord */
    protected $vehicleDetails;
    /** @var string */
    protected $vehicleDocId;
    /** @var \Ep\TecDoc\Record\VehicleRegistrationInfoByIdRecord */
    protected $vehicleRegistrationInfo;
    /** @var \Ep\TecDoc\Record\Seq\WheelBasesByCarIdRecordSeq */
    protected $wheelBases;

    /**
     * @return AxleByCarIdRecordSeq
     */
    public function getAxles(): AxleByCarIdRecordSeq
    {
        return $this->axles;
    }

    /**
     * @return CabsByCarIdRecordSeq
     */
    public function getCabs(): CabsByCarIdRecordSeq
    {
        return $this->cabs;
    }

    /**
     * @return int
     */
    public function getId(): int
    {
        return $this->carId;
    }

    /**
     * @return KbaNumbersByVehicleIdRecordSeq
     */
    public function getKbaNumbers(): KbaNumbersByVehicleIdRecordSeq
    {
        return $this->kbaNumbers;
    }

    /**
     * @return MotorCodesByCarIdRecordSeq
     */
    public function getMotorCodes(): MotorCodesByCarIdRecordSeq
    {
        return $this->motorCodes;
    }

    /**
     * @return VehiclePrototypeRecordSeq
     */
    public function getProtoTypes(): VehiclePrototypeRecordSeq
    {
        return $this->protoTypes;
    }

    /**
     * @return SecondaryTypesByCarIdRecordSeq
     */
    public function getSecondaryTypes(): SecondaryTypesByCarIdRecordSeq
    {
        return $this->secondaryTypes;
    }

    /**
     * @return VehicleByIdRecord
     */
    public function getVehicleDetails(): ?VehicleByIdRecord
    {
        return $this->vehicleDetails;
    }

    /**
     * @return string
     */
    public function getVehicleDocId(): string
    {
        return $this->vehicleDocId;
    }

    /**
     * @return VehicleRegistrationInfoByIdRecord
     */
    public function getVehicleRegistrationInfo(): VehicleRegistrationInfoByIdRecord
    {
        return $this->vehicleRegistrationInfo;
    }

    /**
     * @return WheelBasesByCarIdRecordSeq
     */
    public function getWheelBases(): WheelBasesByCarIdRecordSeq
    {
        return $this->wheelBases;
    }
}