<?php
namespace Ep\TecDoc\Request;

/**
 * Interface RequestInterface
 *
 * @package Ep\TecDoc\Request
 * @author Elektronika Perhoč <support@ep.hr>
 * @link https://bitbucket.org/elektronika-perhoc/tecdoc
 */
interface RequestInterface
{
    /**
     * Vraća ime TecDoc funkcije koju pozivamo na serveru.
     *
     * @return string
     */
    public function getRemoteFunctionName(): string;

    /**
     * Vraća klasu objekta kojeg TecDoc vraća.
     *
     * @return string
     */
    public function getResponseClass(): string;

    /**
     * Vraća ID providera.
     *
     * @return int
     */
    public function getProvider(): ?int;

    /**
     * Postavlja ime providera.
     *
     * @param int $provider
     */
    public function setProvider(int $provider): void;

    /**
     * Vraća ovaj objekt kao array.
     *
     * @return array
     */
    public function toArray(): array;
}