<?php
namespace Ep\TecDoc\Request;

use Ep\TecDoc\Response\VehicleByIds4Response;

/**
 * Class VehicleByIds4Request
 *
 * @package Ep\TecDoc\Request
 * @author Elektronika Perhoč <web@ep.hr>
 * @link http://gitlab.ep.local/ep-framework/tecdoc
 */
class VehicleByIds4Request extends AbstractRequest
{
    /** @var string */
    protected $responseClass = VehicleByIds4Response::class;
    /** @var string */
    protected $remoteFunctionName = 'getVehicleByIds4';
    /** @var string */
    protected $articleCountry;
    /** @var bool */
    protected $axles;
    /** @var bool */
    protected $cabs;
    /** @var int[] */
    protected $carIds;
    /** @var string */
    protected $countriesCarSelection;
    /** @var string */
    protected $country;
    /** @var bool */
    protected $countryGroupFlag;
    /** @var bool */
    protected $kbaData;
    /** @var string */
    protected $lang;
    /** @var bool */
    protected $motorCodes;
    /** @var int */
    protected $numberplateType;
    /** @var bool */
    protected $protoTypes;
    /** @var bool */
    protected $registrationInfo;
    /** @var bool */
    protected $secondaryTypes;
    /** @var bool */
    protected $wheelbases;

    /**
     * @return string
     */
    public function getArticleCountry(): string
    {
        return $this->articleCountry;
    }

    /**
     * @param string $articleCountry
     */
    public function setArticleCountry(string $articleCountry): void
    {
        $this->articleCountry = $articleCountry;
    }

    /**
     * @return bool
     */
    public function isAxles(): bool
    {
        return $this->axles;
    }

    /**
     * @param bool $axles
     */
    public function setAxles(bool $axles): void
    {
        $this->axles = $axles;
    }

    /**
     * @return bool
     */
    public function isCabs(): bool
    {
        return $this->cabs;
    }

    /**
     * @param bool $cabs
     */
    public function setCabs(bool $cabs): void
    {
        $this->cabs = $cabs;
    }

    /**
     * @return int[]
     */
    public function getCarIds(): array
    {
        return $this->carIds;
    }

    /**
     * @param int[] $carIds
     */
    public function setCarIds(array $carIds): void
    {
        $this->carIds = $carIds;
    }

    /**
     * @return string
     */
    public function getCountriesCarSelection(): string
    {
        return $this->countriesCarSelection;
    }

    /**
     * @param string $countriesCarSelection
     */
    public function setCountriesCarSelection(string $countriesCarSelection): void
    {
        $this->countriesCarSelection = $countriesCarSelection;
    }

    /**
     * @return string
     */
    public function getCountry(): ?string
    {
        return $this->country;
    }

    /**
     * @param string $country
     */
    public function setCountry(string $country): void
    {
        $this->country = $country;
    }

    /**
     * @return bool
     */
    public function isCountryGroupFlag(): bool
    {
        return $this->countryGroupFlag;
    }

    /**
     * @param bool $countryGroupFlag
     */
    public function setCountryGroupFlag(bool $countryGroupFlag): void
    {
        $this->countryGroupFlag = $countryGroupFlag;
    }

    /**
     * @return bool
     */
    public function isKbaData(): bool
    {
        return $this->kbaData;
    }

    /**
     * @param bool $kbaData
     */
    public function setKbaData(bool $kbaData): void
    {
        $this->kbaData = $kbaData;
    }

    /**
     * @return string
     */
    public function getLang(): ?string
    {
        return $this->lang;
    }

    /**
     * @param string $lang
     */
    public function setLang(string $lang): void
    {
        $this->lang = $lang;
    }

    /**
     * @return bool
     */
    public function isMotorCodes(): bool
    {
        return $this->motorCodes;
    }

    /**
     * @param bool $motorCodes
     */
    public function setMotorCodes(bool $motorCodes): void
    {
        $this->motorCodes = $motorCodes;
    }

    /**
     * @return int
     */
    public function getNumberplateType(): int
    {
        return $this->numberplateType;
    }

    /**
     * @param int $numberplateType
     */
    public function setNumberplateType(int $numberplateType): void
    {
        $this->numberplateType = $numberplateType;
    }

    /**
     * @return bool
     */
    public function isProtoTypes(): bool
    {
        return $this->protoTypes;
    }

    /**
     * @param bool $protoTypes
     */
    public function setProtoTypes(bool $protoTypes): void
    {
        $this->protoTypes = $protoTypes;
    }

    /**
     * @return bool
     */
    public function isRegistrationInfo(): bool
    {
        return $this->registrationInfo;
    }

    /**
     * @param bool $registrationInfo
     */
    public function setRegistrationInfo(bool $registrationInfo): void
    {
        $this->registrationInfo = $registrationInfo;
    }

    /**
     * @return bool
     */
    public function isSecondaryTypes(): bool
    {
        return $this->secondaryTypes;
    }

    /**
     * @param bool $secondaryTypes
     */
    public function setSecondaryTypes(bool $secondaryTypes): void
    {
        $this->secondaryTypes = $secondaryTypes;
    }

    /**
     * @return bool
     */
    public function isWheelbases(): bool
    {
        return $this->wheelbases;
    }

    /**
     * @param bool $wheelbases
     */
    public function setWheelbases(bool $wheelbases): void
    {
        $this->wheelbases = $wheelbases;
    }
}