<?php

namespace Ep\TecDoc\Request;

class VehicleIdsByKeyNumberPlates3Request extends AbstractRequest
{
    /** @var string */
    protected $articleCountry;

    use Parts\CountriesCarSelectionTrait;

    use Parts\CountryGroupFlagTrait;

    use Parts\KeySystemNumberTrait;

    use Parts\KeySystemTypeTrait;

    use Parts\LangTrait;


    /**
     * @return string
     */
    public function getArticleCountry(): string
    {
        return $this->articleCountry;
    }

    /**
     * @param string $articleCountry
     */
    public function setArticleCountry(string $articleCountry): void
    {
        $this->articleCountry = $articleCountry;
    }

    public function toJson()
    {
        $params = [
            'getVehicleIdsByKeyNumberPlates3' => [
                'countriesCarSelection' => $this->countriesCarSelection,
                'countryGroupFlag' => $this->countryGroupFlag,
                'keySystemNumber' => $this->keySystemNumber,
                'keySystemType' => $this->keySystemType,
                'lang' => $this->lang,
                'provider' => $this->provider,
            ],
        ];
        if (null !== $this->articleCountry) {
            $params['getVehicleIdsByKeyNumberPlates3']['articleCountry'] = $this->articleCountry;
        }

        return json_encode($params);
    }
}

