<?php

namespace Ep\TecDoc\Request;

class VehiclesByKeyNumberPlatesRequest extends AbstractRequest
{
    /** @var string */
    protected $companyName;

    /** @var string */
    protected $country;

    /** @var bool */
    protected $details;

    /** @var string */
    protected $endCustomerPassword;

    /** @var string */
    protected $endCustomerUsername;

    /** @var string */
    protected $idKey;

    /** @var string */
    protected $initials;

    use Parts\KeySystemNumberTrait;

    use Parts\KeySystemTypeTrait;

    use Parts\LangTrait;

    use Parts\LinkingTargetTypeTrait;

    /** @var string */
    protected $mandatorPassword;

    /** @var string */
    protected $mandatorUsername;

    /** @var bool */
    protected $picture;

    /** @var string */
    protected $productId;

    /** @var string */
    protected $serviceName;

    /**
     * @return string
     */
    public function getServiceName(): string
    {
        return $this->serviceName;
    }

    /**
     * @param string $serviceName
     */
    public function setServiceName(string $serviceName): void
    {
        $this->serviceName = $serviceName;
    }

    /**
     * @return string
     */
    public function getProductId(): string
    {
        return $this->productId;
    }

    /**
     * @param string $productId
     */
    public function setProductId(string $productId): void
    {
        $this->productId = $productId;
    }

    /**
     * @return bool
     */
    public function isPicture(): bool
    {
        return $this->picture;
    }

    /**
     * @param bool $picture
     */
    public function setPicture(bool $picture): void
    {
        $this->picture = $picture;
    }

    /**
     * @return string
     */
    public function getMandatorUsername(): string
    {
        return $this->mandatorUsername;
    }

    /**
     * @param string $mandatorUsername
     */
    public function setMandatorUsername(string $mandatorUsername): void
    {
        $this->mandatorUsername = $mandatorUsername;
    }

    /**
     * @return string
     */
    public function getMandatorPassword(): string
    {
        return $this->mandatorPassword;
    }

    /**
     * @param string $mandatorPassword
     */
    public function setMandatorPassword(string $mandatorPassword): void
    {
        $this->mandatorPassword = $mandatorPassword;
    }

    /**
     * @return string
     */
    public function getInitials(): string
    {
        return $this->initials;
    }

    /**
     * @param string $initials
     */
    public function setInitials(string $initials): void
    {
        $this->initials = $initials;
    }

    /**
     * @return string
     */
    public function getIdKey(): string
    {
        return $this->idKey;
    }

    /**
     * @param string $idKey
     */
    public function setIdKey(string $idKey): void
    {
        $this->idKey = $idKey;
    }

    /**
     * @return string
     */
    public function getEndCustomerUsername(): string
    {
        return $this->endCustomerUsername;
    }

    /**
     * @param string $endCustomerUsername
     */
    public function setEndCustomerUsername(string $endCustomerUsername): void
    {
        $this->endCustomerUsername = $endCustomerUsername;
    }

    /**
     * @return string
     */
    public function getEndCustomerPassword(): string
    {
        return $this->endCustomerPassword;
    }

    /**
     * @param string $endCustomerPassword
     */
    public function setEndCustomerPassword(string $endCustomerPassword): void
    {
        $this->endCustomerPassword = $endCustomerPassword;
    }

    /**
     * @return bool
     */
    public function isDetails(): bool
    {
        return $this->details;
    }

    /**
     * @param bool $details
     */
    public function setDetails(bool $details): void
    {
        $this->details = $details;
    }

    /**
     * @return string
     */
    public function getCountry(): string
    {
        return $this->country;
    }

    /**
     * @param string $country
     */
    public function setCountry(string $country): void
    {
        $this->country = $country;
    }

    /**
     * @return string
     */
    public function getCompanyName(): string
    {
        return $this->companyName;
    }

    /**
     * @param string $companyName
     */
    public function setCompanyName(string $companyName): void
    {
        $this->companyName = $companyName;
    }


    public function toJson()
    {
        $params = [
            'getVehiclesByKeyNumberPlates' => [
                'country' => $this->country,
                'keySystemNumber' => $this->keySystemNumber,
                'keySystemType' => $this->keySystemType,
                'provider' => $this->provider,
            ],
        ];

        $optional  = array(
            'companyName',
            'details',
            'endCustomerPassword',
            'endCustomerUsername',
            'idKey',
            'initials',
            'linkingTargetType',
            'mandatorPassword',
            'mandatorUsername',
            'picture',
            'productId',
            'serviceName',
        );

        foreach ($optional as $argName)
        {
            if (null !== $this->$argName) {
                $params['getVehicleIdsByKeyNumberPlates3'][$argName] = $this->$argName;
            }
        }
    }

}