<?php
namespace EpTest\TecDoc\Form\Element;

use Ep\TecDoc\Form\Element\VehicleManufacturer;
use EpTest\TecDoc\TecDocAwareTrait;
use PHPUnit\Framework\TestCase;
use Zend\ServiceManager\AbstractPluginManager;

/**
 * Class VehicleManufacturerTest
 *
 * @package EpTest\TecDoc\Form\Element
 * @author Elektronika Perhoč <web@ep.hr>
 * @link http://gitlab.ep.local/ep-framework/tecdoc
 */
class VehicleManufacturerTest extends TestCase
{
    use TecDocAwareTrait;

    public function testElementGetsValuesFromTecDoc()
    {
        $container = $this->createContainer();
        /** @var AbstractPluginManager $formElements */
        $formElements = $container->get('FormElementManager');

        /** @var VehicleManufacturer $element */
        $element = $formElements->get('tecdoc.vehicle_manufacturer', [
            'name' => 'manufacturers',
        ]);

        $this->assertInstanceOf(VehicleManufacturer::class, $element);
        $this->assertEquals('manufacturers', $element->getName());

        $valueOptions = $element->getValueOptions();

        $this->assertTrue(count($valueOptions) > 1);
    }
}